<template>
  <div class="sm:container sm:mx-auto flex login-module">
    <div class="xl:w-[1200px] flex-none sm:m-auto bg-background5 rounded-2xl overflow-hidden w-full login-container">
      <div class="h-[64px] bg-background5 flex items-center justify-between py-0 pl-[40px] pr-[16px] title-wrapper">
        <h1 class="text-left text-2xl font-semibold text-[var(--secondary)] title">{{ $t('capital_log_in') }}</h1>
        <close-button />
      </div>
      <div class="w-full h-[2px] bg-border"></div>
      <div class="flex justify-between" :class="{'form-only' : loginRegister.IsHidden}">
        <div class="xl:w-[400px] py-6 px-10 overflow-hidden bg-background5">
          <el-form
            ref="loginFormRef"
            :model="loginFormData"
            :rules="loginRules"
            :validate-on-rule-change="false"
            label-position="left"

          >
            <el-form-item :label="$t('username')" prop="Username">
              <el-input
              v-model="loginFormData.Username"
              :disabled="isLoginProccessing"
              type="text"/>
            </el-form-item>
            <el-form-item :label="$t('password')" prop="Password">
              <el-input
              v-model="loginFormData.Password"
              :disabled="isLoginProccessing"
              type="password"/>
            </el-form-item>
            <el-divider class="bg-border my-6" />
            <div class="btn-click-captcha-to-verify">
              <el-form-item
              v-if="!clientCaptcha.IsHidden"
              prop="Captcha"
              :show-message="true"
              >
                <div id="captcha-button">
                  <div id="captcha-pop-up-verify" class="w-full">
                    <template v-if="!captchaErrorMsg.length && loginFormData.Captcha.length == 5 && !isDialogVisible">
                      <div class="relative w-[18px] h-[18px]">
                        <img :src="getAssetImage('assets/theme/light_flexible_1/desktop/images/menu/captcha-success.png')"
                          alt="verify icon success" loading="lazy">
                      </div>
                      <span class="whitespace-nowrap">{{ $t('successful_verification') }}</span>
                    </template>
                    <template v-else>
                      <div class="flex justify-center items-center gap-1 w-full" @click="isDialogVisible = true">
                        <div class="relative w-[18px] h-[18px]">
                          <img :src="getAssetImage('assets/theme/light_flexible_1/desktop/images/menu/capcha.png')"
                            alt="verify icon" loading="lazy">
                        </div>
                        <span>{{ $t('click_to_verify') }}</span>
                      </div>
                    </template>
                  </div>
                </div>
              </el-form-item>
            </div>
            <div class="mt-6 text-center">
              <el-button v-on:click="submitLogin(loginFormRef)" :disabled="isLoginProccessing" class="px-4 py-1 text-sm w-full rounded btn bg-secondary"><b>{{ $t('log_in') }}</b></el-button>
            </div>
            <theme-desktop-peru-components-auth-forgot-password-modal />
            <div v-if="!register.IsHidden">
              <div class="text-center fc-text4 text-[12px] pt-4">{{ $t('dont_have_an_account?') }}
                <nuxt-link
                  class="text-primary underline cursor-pointer"
                  to="/register"
                  :id="ID.SIGNUP"
                  >{{ $t("joinnow") }}
                </nuxt-link>
              </div>
            </div>
            <theme-common-telegram-login-button
              :is-show="isTelegramBotSetup"
              :username="telegramBotUsername"
              @callback="telegramCallbackFunction"
            />
          </el-form>
        </div>
        <div v-if="!loginRegister.IsHidden" :class="`xl:w-[800px] relative register-info h-[654px] flex justify-center flex-col items-center text-center login-register-image ol-bg-light ${clientCaptcha.IsHidden ? 'h-without-captcha' : 'h-with-captcha' }`">
          <div class="text-center">
            <div class="w-[752px] [504px]">
              <img :src="loginRegister.ImagePath" class="w-full h-full object-contain" />
            </div>
            <div class="text-primary text-2xl font-black mb-1">
              <span>{{ $t('welcome_to') }}</span>
              <span v-if="!companyName.IsHidden" class="font-black text-[32px] fc-text4 ml-1">{{ companyName.Text }}</span>
            </div>
            <div class="text-base fc-text4">{{ $t(loginRegister.Text) }}</div>
          </div>
        </div>
      </div>
    </div>
  </div>
  <div class="captcha-dialog-container">
    <el-dialog
      align-center
      destroy-on-close
      :show-close="false"
      custom-class="p-[15px] captcha-dialog"
      v-model="isDialogVisible"
      width="320px"
      @open="loginFormData.Captcha = ''"
      @close="loginFormRef?.validateField('Captcha')"
      >
      <utils-client-captcha v-if="!clientCaptcha.IsHidden" v-model:captcha="loginFormData.Captcha"
        v-model:dialogVisible="isDialogVisible" :get-error-message="getCaptchaErrorMsg"
        :is-invalid="captchaErrorMsg.length > 0" />
    </el-dialog>
  </div>
</template>

<script lang="ts">
import {
  computed,
  defineComponent, ref,
} from 'vue';
import useLogin from '@/composables/useLogin';
import { clientCaptcha } from '@/composables/captcha/useCaptcha';
import { IThemePropertiesFromApi } from '@/models/companyThemePropertiesRespone';
import { store } from '@/store';

export default defineComponent({
  name: 'Login',
  setup() {
    const themeProperties = computed(() => store.state.companyThemePropertiesFromApi.ThemeProperties);
    const themeColor = computed((): IThemePropertiesFromApi => themePropertyHelper.getSingleThemeProperty(themeProperties.value, 'theme_color'));
    const {
      loginFormRef,
      loginFormData,
      loginRules,
      submitLogin,
      isLoginProccessing,
      captchaErrorMsg,
      getCaptchaErrorMsg,
      isTelegramBotSetup,
      telegramBotUsername,
      telegramCallbackFunction,
      checkLoginTelegramSetup,
    } = useLogin();
    checkLoginTelegramSetup();
    const { getAssetImage } = commonHelper;
    const selectedThemeName = store.state.selectedThemeName;
    const isDialogVisible = ref(false);
    const register = computed(
    (): IThemePropertiesFromApi =>
      themePropertyHelper.getSingleThemeProperty(
        themeProperties.value,
        "register"
      )
    );
    const loginRegister = computed(
    (): IThemePropertiesFromApi =>
      themePropertyHelper.getSingleThemeProperty(
        themeProperties.value,
        "login_register"
      )
    );
    const companyName = computed(
    (): IThemePropertiesFromApi =>
      themePropertyHelper.getSingleThemeProperty(
        themeProperties.value,
        "login_register_company_name"
      )
    );
    return {
      getAssetImage,
      companyName,
      themeColor,
      loginFormRef,
      loginFormData,
      loginRules,
      submitLogin,
      isLoginProccessing,
      clientCaptcha,
      captchaErrorMsg,
      getCaptchaErrorMsg,
      isDialogVisible,
      loginRegister,
      selectedThemeName,
      register,
      isTelegramBotSetup,
      telegramBotUsername,
      telegramCallbackFunction,
    };
  },
});
</script>
<style scoped lang="scss">
.login-register-image {
  --bg-base-color: var(--background5);
  --bg-opacity: 5%;
}
:deep(.forgot-password-form-item.main_orange .forgot-password-entry-link) {
  color: var(--primary);
}
.login{
  display: block;
}
.el-form-item {
  display: block;
  margin-bottom: 16px;
}
.text-primary {
  color: var(--primary);
}
.el-button.is-round {
  border-radius: 4px;
}
:deep(.forgot-password-form-item .el-form-item__content) {
  margin: 0;
  justify-content: center;
  line-height: 0;
  margin-top: 20px;
}
:deep(.el-form-item__label) {
  color: var(--text5);
  font-size: 14px;
}
.bg-border {
  border-color: var(--border);
}
.login-container {
  @media screen and (max-width: 424px) {
    border-radius: 0;
  }
  .title-wrapper {
    @media screen and (max-width: 424px) {
      padding: 1.5rem;
    }
  }
  .login-register-form {
    @media screen and (max-width: 424px) {
      padding: 1.5rem;
    }
  }
}
.login-module {
  @media screen and (max-width: 639px) {
    padding: 1rem;
  }
  @media screen and (max-width: 424px) {
    padding: 0;
  }
}
:deep(.el-form-item:not(.is-error) .el-input__inner:hover), :deep(.el-form-item:not(.is-error) .el-select:hover .el-input__inner) {
  outline: 0;
  box-shadow: 0 0 0 1px var(--border) inset !important;
}
:deep(.el-form-item:not(.is-error) .el-input__inner:focus), :deep(.el-form-item:not(.is-error) .el-select .el-input.is-focus .el-input__inner) {
  outline: 0;
  box-shadow: 0 0 0 1px var(--selected) inset !important;
}

.login-module .form-only .login-register-form {
  max-width: 600px;
  width: 100%;
  margin: 0 auto;
}
</style>